import { compose } from 'redux';
import { ensureAsync } from './helpers/promises';

var chain = function chain() {
  for (var _len = arguments.length, thunks = Array(_len), _key = 0; _key < _len; _key++) {
    thunks[_key] = arguments[_key];
  }

  if (Array.isArray(thunks[0])) {
    // supporting previous interface of the chain decorator
    thunks = thunks[0];
  }

  return function () {
    for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    return function (dispatch) {
      var first = thunks[0];
      var initial = ensureAsync(compose(dispatch, first));

      return thunks.slice(1).reduce(function (promise, thunk) {
        return promise.then(compose(dispatch, thunk));
      }, initial.apply(undefined, args));
    };
  };
};

export default chain;