var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

import { mapKeys } from './map-keys';

var bindSelector = function bindSelector(getState) {
  return function (selector) {
    return function () {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return selector.apply(undefined, [getState()].concat(args));
    };
  };
};

var bindActionCreator = function bindActionCreator(dispatch) {
  return function (actionCreator) {
    return function () {
      return dispatch(actionCreator.apply(undefined, arguments));
    };
  };
};

var mapWith = function mapWith(createBinder) {
  return function (methods, storeMethod) {
    var typeOfMethods = typeof methods === 'undefined' ? 'undefined' : _typeof(methods);

    if (typeOfMethods === 'function') {
      return methods(storeMethod);
    }

    var binder = createBinder(storeMethod);

    if (Array.isArray(methods)) {
      return methods.map(binder);
    }

    if (typeOfMethods === 'object') {
      return mapKeys(methods, binder);
    }

    return storeMethod;
  };
};

export var bindSelectors = mapWith(bindSelector);
export var bindActionCreators = mapWith(bindActionCreator);