import { ensureAsyncCompose } from './helpers/promises';

var queue = function queue() {
  for (var _len = arguments.length, thunks = Array(_len), _key = 0; _key < _len; _key++) {
    thunks[_key] = arguments[_key];
  }

  return function () {
    for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    return function (dispatch) {
      var initial = ensureAsyncCompose(dispatch, thunks[0]);
      return thunks.slice(1).reduce(function (promise, thunk) {
        return promise.then(function () {
          return dispatch(thunk.apply(undefined, args));
        });
      }, initial.apply(undefined, args));
    };
  };
};

export default queue;